%%
%% $Id: ebnf.tex,v 1.4 2002-02-01 11:26:24 mbaur Exp $
%%
%% This file supplies an EBNF figure for the JNuke serializer
%% documentation. Once this file is \include'd, it is available as 
%% \EBNFfigure.
%%

\newcommand{\EBNFfigure}{
    \begin{figure}[ht!]
    \begin{center}

    \footnotesize
    \framebox{
    \begin{tabular}{rcl}
    $<$Stream$>$     & = & $<$Command$>$ $|$ $<$Stream$>$ $<$Command$>$. \\
    $<$Command$>$    & = & $<$Reference$>$ $|$ $<$Definition$>$. \\
    $<$Reference$>$  & = & \texttt{"("} \texttt{"ref"} $<$Address$>$ \texttt{")"}. \\
    $<$Definition$>$ & = & \texttt{"("} \texttt{"def"} $<$Address$>$
                           \texttt{"("} $<$Type$>$ [\texttt{"("} 
			   $<$Arguments$>$ \texttt{")"}] \texttt{")"}. \\
    $<$Literal$>$    & = & \texttt{"("} \texttt{"int"} $<$Digits$>$ \texttt{")"}. \\
    $<$Type$>$       & = & \texttt{"JNukePair"} $|$ \texttt{"JNukeNode"} $|$ \ldots. \\
    $<$Arguments$>$  & = & $<$Argument$>$ $|$ $<$Arguments$>$ $<$Argument$>$. \\
    $<$Argument$>$   & = & $<$Reference$>$ $|$ $<$Literal$>$. \\
    $<$Address$>$    & = & \texttt{"0x"} $<$HexDigits$>$. \\
    $<$HexDigits$>$  & = & $<$HexDigit$>$ $|$ $<$HexDigits$>$ $<$HexDigit$>$. \\
    $<$HexDigit$>$   & = & $<$Digit$>$ $|$ \texttt{"A"} $|$ \texttt{"B"} $|$ \ldots $|$ \texttt{"F"}. \\
    $<$Digits$>$     & = & $<$Digit$>$ $|$ $<$Digits$>$ $<$Digit$>$. \\
    $<$Digit$>$      & = & \texttt{"0"} $|$ \texttt{"1"} $|$ \ldots $|$ \texttt{"9"}. 
    \end{tabular}}
    \normalsize
    \end{center}
    \label{ebnf}
    \caption{EBNF of serialization stream}
    \end{figure}
}

%% EOF
